
//考虑使用PageView，需与ITab_navigator结合使用
//应尽可能的使用push，同时考虑pages用两个pageview
以下的组件可作为pages的内容
    return PageView.builder(
      controller: _pageController,
      itemCount: _pageItems.length,
      itemBuilder: _itemBuilder,
      physics: const NeverScrollableScrollPhysics(),
    );
class TabItem {
  String url;
  String currentUrl;
  Page? defaultPage;
  bool alive;
  TabItem(String this.url, [this.alive = false]) : currentUrl = url;
}

class TabRouter {
  List<TabItem> items = [];
  Map<String, Widget?> alivesWidget = {};
  final PageController pageController = PageController();
  final IRouter routeState;
  String? currentUrl;

  TabRouter(this.routeState, List<String> urls,
      [List<String> alives = const []]) {
    for (int i = 0; i < urls.length; i++) {
      items.add(TabItem(urls[i]));
    }
    if (alives.isNotEmpty) {
      alivesWidget = {};
      for (int i = 0; i < alives.length; i++) {
        alivesWidget[alives[i]] = null;
      }
    }
  }
  bool isAlive(String url) {
    if (alivesWidget.isEmpty) return false;
    if (alivesWidget.containsKey(url)) return true;
    return false;
  }

  //这里index参数无用，因为页号直接从routeState得到
  //这里的index是pageController的当前index
  //这里的currentUrl完全可以使用routeState.route.path，这样push的时候，这里会收到
  Widget itemBuilder(context, index) {
    //此时仅仅切换page
    var item = items[index];
    if (currentUrl != null) {
      item.currentUrl = currentUrl!;
      currentUrl = null; //已经得到组件，恢复currentUrl
    }

    if (isAlive(item.currentUrl) && alivesWidget[item.currentUrl] != null) {
      return alivesWidget[item.currentUrl]!;
    }

    var widget = routeState.getWidget(item.currentUrl);
    if (isAlive(item.currentUrl)) alivesWidget[item.currentUrl] = widget;
    return widget;
  }
}