import 'package:flutter/material.dart';
import '../../../irouter.dart';
import 'package:url_launcher/link.dart';

class FirstPage extends StatefulWidget {
  const FirstPage({Key? key}) : super(key: key);

  @override
  _FirstPageState createState() => _FirstPageState();
}

class _FirstPageState
    extends State<FirstPage> //with AutomaticKeepAliveClientMixin<Home>
{
  int _counter = 0;

  void _incrementCounter() {
    setState(() {
      _counter++;
    });
  }

  @override
  Widget build(BuildContext context) {
    debugPrint('build first');
    //super.build(context);
    return Scaffold(
      appBar: AppBar(
        title: const Text('First'),
      ),

      body: Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            ...[
              //这里直接用link,那么没有ipage参数
              Link(
                uri: Uri.parse('/second:ipage=1'),
                builder: (context, followLink) => TextButton(
                  onPressed: followLink,
                  child: const Text('Go directly to /second (Link),在1号页面显示'),
                ),
              ),
              TextButton(
                child:
                    const Text('Go directly to /second (RouteState)，直接在0号页面显示'),
                onPressed: () {
                  IRouter.push(context, '/second', 0);
                },
              ),
            ].map((w) => Padding(padding: const EdgeInsets.all(8), child: w)),
            TextButton(
              onPressed: () => showDialog<String>(
                context: context,
                builder: (context) => AlertDialog(
                  title: const Text('Alert!'),
                  content: const Text('The alert description goes here.'),
                  actions: [
                    TextButton(
                      onPressed: () => Navigator.pop(context, 'Cancel'),
                      child: const Text('Cancel'),
                    ),
                    TextButton(
                      onPressed: () => Navigator.pop(context, 'OK'),
                      child: const Text('OK'),
                    ),
                  ],
                ),
              ),
              child: const Text('Show Dialog'),
            ),
            const Text(
              'First Page: not keep state',
              style: TextStyle(fontWeight: FontWeight.bold, fontSize: 25.0),
            ),
            const Text(
              'You have pushed the button this many times:',
            ),
            Text(
              '$_counter',
              style: const TextStyle(
                  fontWeight: FontWeight.bold,
                  fontSize: 35.0,
                  color: Colors.blue),
            ),
          ],
        ),
      ),
      floatingActionButton: FloatingActionButton(
        onPressed: _incrementCounter,
        tooltip: 'Increment',
        child: const Icon(Icons.add),
      ), // This trailing comma makes auto-formatting nicer for build methods.
    );
  }

  //@override
  //bool get wantKeepAlive => true;
}
